=== modified file 'NEWS'
--- NEWS	2006-04-02 01:50:42 +0000
+++ NEWS	2006-04-06 13:07:40 +0000
@@ -118,6 +118,9 @@
     * Progress bars are now nested - see
       bzrlib.ui.ui_factory.nested_progress_bar. (Robert Collins, Robey Pointer)
 
+    * New API call get_format_description() for each type of format.
+      (Olaf Conradi)
+
   TESTING:
 
     * SFTP tests now shortcut the SSH negotiation, reducing test overhead

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2006-03-29 15:07:34 +0000
+++ bzrlib/branch.py	2006-04-06 13:07:40 +0000
@@ -566,6 +566,10 @@
         """Return the ASCII format string that identifies this format."""
         raise NotImplementedError(self.get_format_string)
 
+    def get_format_description(self):
+        """Return the short format description for this format."""
+        raise NotImplementedError(self.get_format_string)
+
     def initialize(self, a_bzrdir):
         """Create a branch of this format in a_bzrdir."""
         raise NotImplementedError(self.initialized)
@@ -612,6 +616,10 @@
      - a branch-lock lock file [ to be shared with the bzrdir ]
     """
 
+    def get_format_description(self):
+        """See BranchFormat.get_format_description()."""
+        return "Branch format 4"
+
     def initialize(self, a_bzrdir):
         """Create a branch of this format in a_bzrdir."""
         mutter('creating branch in %s', a_bzrdir.transport.base)
@@ -668,6 +676,10 @@
     def get_format_string(self):
         """See BranchFormat.get_format_string()."""
         return "Bazaar-NG branch format 5\n"
+
+    def get_format_description(self):
+        """See BranchFormat.get_format_description()."""
+        return "Branch format 5"
         
     def initialize(self, a_bzrdir):
         """Create a branch of this format in a_bzrdir."""
@@ -725,6 +737,10 @@
     def get_format_string(self):
         """See BranchFormat.get_format_string()."""
         return "Bazaar-NG Branch Reference Format 1\n"
+
+    def get_format_description(self):
+        """See BranchFormat.get_format_description()."""
+        return "Checkout reference format 1"
         
     def initialize(self, a_bzrdir, target_branch=None):
         """Create a branch of this format in a_bzrdir."""

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2006-03-22 13:21:14 +0000
+++ bzrlib/bzrdir.py	2006-04-06 13:07:40 +0000
@@ -870,6 +870,10 @@
         """Return the ASCII format string that identifies this format."""
         raise NotImplementedError(self.get_format_string)
 
+    def get_format_description(self):
+        """Return the short description for this format."""
+        raise NotImplementedError(self.get_format_description)
+
     def get_converter(self, format=None):
         """Return the converter to use to convert bzrdirs needing converts.
 
@@ -977,6 +981,10 @@
         """See BzrDirFormat.get_format_string()."""
         return "Bazaar-NG branch, format 0.0.4\n"
 
+    def get_format_description(self):
+        """See BzrDirFormat.get_format_description()."""
+        return "All-in-one format 4"
+
     def get_converter(self, format=None):
         """See BzrDirFormat.get_converter()."""
         # there is one and only one upgrade path here.
@@ -1023,6 +1031,10 @@
         """See BzrDirFormat.get_format_string()."""
         return "Bazaar-NG branch, format 5\n"
 
+    def get_format_description(self):
+        """See BzrDirFormat.get_format_description()."""
+        return "All-in-one format 5"
+
     def get_converter(self, format=None):
         """See BzrDirFormat.get_converter()."""
         # there is one and only one upgrade path here.
@@ -1070,6 +1082,10 @@
         """See BzrDirFormat.get_format_string()."""
         return "Bazaar-NG branch, format 6\n"
 
+    def get_format_description(self):
+        """See BzrDirFormat.get_format_description()."""
+        return "All-in-one format 6"
+
     def get_converter(self, format=None):
         """See BzrDirFormat.get_converter()."""
         # there is one and only one upgrade path here.
@@ -1132,6 +1148,10 @@
         """See BzrDirFormat.get_format_string()."""
         return "Bazaar-NG meta directory, format 1\n"
 
+    def get_format_description(self):
+        """See BzrDirFormat.get_format_description()."""
+        return "Meta directory format 1"
+
     def _open(self, transport):
         """See BzrDirFormat._open."""
         return BzrDirMeta1(transport, self)

=== modified file 'bzrlib/info.py'
--- bzrlib/info.py	2006-04-03 11:21:57 +0000
+++ bzrlib/info.py	2006-04-06 13:07:40 +0000
@@ -44,19 +44,6 @@
         return 's'
 
 
-def _get_format_string(target):
-    """Return format string of target.
-    
-    Target must be of type bzrlib.workingtree, bzrlib.branch or
-    bzrlib.repository.
-
-    """
-    try:
-        return target._format.get_format_string().rstrip()
-    except NotImplementedError:
-        return target.bzrdir._format    # XXX: Use rstrip to be safe?
-
-
 @deprecated_function(zero_eight)
 def show_info(b):
     """Please see show_bzrdir_info."""
@@ -79,47 +66,44 @@
 
     branch = working.branch
     repository = branch.repository
-    working_format = _get_format_string(working)
-    branch_format = _get_format_string(branch)
-    repository_format = _get_format_string(repository)
-    # TODO: metadir_format = ...
+    control_format = working.bzrdir._format.get_format_description()
+    working_format = working._format.get_format_description()
+    branch_format = branch._format.get_format_description()
+    repository_format = repository._format.get_format_description()
 
     print 'Location:'
     if working.bzrdir != branch.bzrdir:
         # Lightweight checkout
-        print '        checkout root: %s' % (
+        print '       checkout root: %s' % (
             working.bzrdir.root_transport.base)
-        print '   checkout of branch: %s' % (
+        print '  checkout of branch: %s' % (
             branch.bzrdir.root_transport.base)
     else:
         # Standalone or bound branch (normal checkout)
-        print '          branch root: %s' % (
+        print '         branch root: %s' % (
             branch.bzrdir.root_transport.base)
         if branch.get_bound_location():
-            print '      bound to branch: %s' % branch.get_bound_location()
+            print '     bound to branch: %s' % branch.get_bound_location()
 
     if repository.bzrdir != branch.bzrdir:
         if repository.is_shared():
-            print '    shared repository: %s' % (
+            print '   shared repository: %s' % (
                 repository.bzrdir.root_transport.base)
         else:
-            print '           repository: %s' % (
+            print '          repository: %s' % (
                 repository.bzrdir.root_transport.base)
 
     if branch.get_parent():
-        print '        parent branch: %s' % branch.get_parent()
+        print '       parent branch: %s' % branch.get_parent()
     if branch.get_push_location():
-        print '       push to branch: %s' % branch.get_push_location()
+        print '      push to branch: %s' % branch.get_push_location()
 
     print
     print 'Format:'
-    if working_format == branch_format == repository_format:
-        print '        branch format: %s' % branch_format
-    else:
-        # TODO: print 'meta directory format: %s' % metadir_format
-        print '  working tree format: %s' % working_format
-        print '        branch format: %s' % branch_format
-        print '    repository format: %s' % repository_format
+    print '       control: %s' % control_format
+    print '  working tree: %s' % working_format
+    print '        branch: %s' % branch_format
+    print '    repository: %s' % repository_format
 
     basis = working.basis_tree()
     work_inv = working.inventory

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2006-03-20 09:58:25 +0000
+++ bzrlib/repository.py	2006-04-06 13:07:40 +0000
@@ -871,6 +871,10 @@
         """
         raise NotImplementedError(self.get_format_string)
 
+    def get_format_description(self):
+        """Return the short desciption for this format."""
+        raise NotImplementedError(self.get_format_description)
+
     def _get_revision_store(self, repo_transport, control_files):
         """Return the revision store object for this a_bzrdir."""
         raise NotImplementedError(self._get_revision_store)
@@ -1041,6 +1045,10 @@
         super(RepositoryFormat4, self).__init__()
         self._matchingbzrdir = bzrlib.bzrdir.BzrDirFormat4()
 
+    def get_format_description(self):
+        """See RepositoryFormat.get_format_description()."""
+        return "Repository format 4"
+
     def initialize(self, url, shared=False, _internal=False):
         """Format 4 branches cannot be created."""
         raise errors.UninitializableFormat(self)
@@ -1086,6 +1094,10 @@
         super(RepositoryFormat5, self).__init__()
         self._matchingbzrdir = bzrlib.bzrdir.BzrDirFormat5()
 
+    def get_format_description(self):
+        """See RepositoryFormat.get_format_description()."""
+        return "Weave repository format 5"
+
     def _get_revision_store(self, repo_transport, control_files):
         """See RepositoryFormat._get_revision_store()."""
         """Return the revision store object for this a_bzrdir."""
@@ -1112,6 +1124,10 @@
         super(RepositoryFormat6, self).__init__()
         self._matchingbzrdir = bzrlib.bzrdir.BzrDirFormat6()
 
+    def get_format_description(self):
+        """See RepositoryFormat.get_format_description()."""
+        return "Weave repository format 6"
+
     def _get_revision_store(self, repo_transport, control_files):
         """See RepositoryFormat._get_revision_store()."""
         return self._get_text_rev_store(repo_transport,
@@ -1181,6 +1197,10 @@
         """See RepositoryFormat.get_format_string()."""
         return "Bazaar-NG Repository format 7"
 
+    def get_format_description(self):
+        """See RepositoryFormat.get_format_description()."""
+        return "Weave repository format 7"
+
     def _get_revision_store(self, repo_transport, control_files):
         """See RepositoryFormat._get_revision_store()."""
         return self._get_text_rev_store(repo_transport,
@@ -1271,6 +1291,10 @@
         """See RepositoryFormat.get_format_string()."""
         return "Bazaar-NG Knit Repository Format 1"
 
+    def get_format_description(self):
+        """See RepositoryFormat.get_format_description()."""
+        return "Knit repository format 1"
+
     def _get_revision_store(self, repo_transport, control_files):
         """See RepositoryFormat._get_revision_store()."""
         from bzrlib.store.revision.knit import KnitRevisionStore

=== modified file 'bzrlib/tests/blackbox/test_info.py'
--- bzrlib/tests/blackbox/test_info.py	2006-04-06 01:15:56 +0000
+++ bzrlib/tests/blackbox/test_info.py	2006-04-06 13:07:40 +0000
@@ -43,10 +43,13 @@
         out, err = self.runbzr('info standalone')
         self.assertEqualDiff(
 """Location:
-          branch root: %s
+         branch root: %s
 
 Format:
-        branch format: Bazaar-NG branch, format 6
+       control: All-in-one format 6
+  working tree: Working tree format 2
+        branch: Branch format 4
+    repository: Weave repository format 6
 
 In the working tree:
          0 unchanged
@@ -77,12 +80,15 @@
         out, err = self.runbzr('info branch')
         self.assertEqualDiff(
 """Location:
-          branch root: %s
-        parent branch: %s
-       push to branch: %s
+         branch root: %s
+       parent branch: %s
+      push to branch: %s
 
 Format:
-        branch format: Bazaar-NG branch, format 6
+       control: All-in-one format 6
+  working tree: Working tree format 2
+        branch: Branch format 4
+    repository: Weave repository format 6
 
 In the working tree:
          1 unchanged
@@ -121,14 +127,15 @@
         out, err = self.runbzr('info bound')
         self.assertEqualDiff(
 """Location:
-          branch root: %s
-      bound to branch: %s
-        parent branch: %s
+         branch root: %s
+     bound to branch: %s
+       parent branch: %s
 
 Format:
-  working tree format: Bazaar-NG Working Tree format 3
-        branch format: Bazaar-NG branch format 5
-    repository format: Bazaar-NG Repository format 7
+       control: Meta directory format 1
+  working tree: Working tree format 3
+        branch: Branch format 5
+    repository: Weave repository format 7
 
 In the working tree:
          1 unchanged
@@ -165,13 +172,14 @@
         out, err = self.runbzr('info checkout')
         self.assertEqualDiff(
 """Location:
-          branch root: %s
-      bound to branch: %s
+         branch root: %s
+     bound to branch: %s
 
 Format:
-  working tree format: Bazaar-NG Working Tree format 3
-        branch format: Bazaar-NG branch format 5
-    repository format: Bazaar-NG Repository format 7
+       control: Meta directory format 1
+  working tree: Working tree format 3
+        branch: Branch format 5
+    repository: Weave repository format 7
 
 In the working tree:
          1 unchanged
@@ -210,13 +218,14 @@
         out, err = self.runbzr('info lightcheckout')
         self.assertEqualDiff(
 """Location:
-        checkout root: %s
-   checkout of branch: %s
+       checkout root: %s
+  checkout of branch: %s
 
 Format:
-  working tree format: Bazaar-NG Working Tree format 3
-        branch format: Bazaar-NG branch, format 6
-    repository format: Bazaar-NG branch, format 6
+       control: Meta directory format 1
+  working tree: Working tree format 3
+        branch: Branch format 4
+    repository: Weave repository format 6
 
 In the working tree:
          1 unchanged
@@ -253,12 +262,15 @@
         out, err = self.runbzr('info branch')
         self.assertEqualDiff(
 """Location:
-          branch root: %s
-        parent branch: %s
-       push to branch: %s
+         branch root: %s
+       parent branch: %s
+      push to branch: %s
 
 Format:
-        branch format: Bazaar-NG branch, format 6
+       control: All-in-one format 6
+  working tree: Working tree format 2
+        branch: Branch format 4
+    repository: Weave repository format 6
 
 In the working tree:
          1 unchanged
@@ -289,14 +301,15 @@
         out, err = self.runbzr('info bound')
         self.assertEqualDiff(
 """Location:
-          branch root: %s
-      bound to branch: %s
-        parent branch: %s
+         branch root: %s
+     bound to branch: %s
+       parent branch: %s
 
 Format:
-  working tree format: Bazaar-NG Working Tree format 3
-        branch format: Bazaar-NG branch format 5
-    repository format: Bazaar-NG Repository format 7
+       control: Meta directory format 1
+  working tree: Working tree format 3
+        branch: Branch format 5
+    repository: Weave repository format 7
 
 Branch is out of date: missing 1 revision.
 
@@ -329,13 +342,14 @@
         out, err = self.runbzr('info checkout')
         self.assertEqualDiff(
 """Location:
-          branch root: %s
-      bound to branch: %s
+         branch root: %s
+     bound to branch: %s
 
 Format:
-  working tree format: Bazaar-NG Working Tree format 3
-        branch format: Bazaar-NG branch format 5
-    repository format: Bazaar-NG Repository format 7
+       control: Meta directory format 1
+  working tree: Working tree format 3
+        branch: Branch format 5
+    repository: Weave repository format 7
 
 Branch is out of date: missing 1 revision.
 
@@ -367,13 +381,14 @@
         out, err = self.runbzr('info lightcheckout')
         self.assertEqualDiff(
 """Location:
-        checkout root: %s
-   checkout of branch: %s
+       checkout root: %s
+  checkout of branch: %s
 
 Format:
-  working tree format: Bazaar-NG Working Tree format 3
-        branch format: Bazaar-NG branch, format 6
-    repository format: Bazaar-NG branch, format 6
+       control: Meta directory format 1
+  working tree: Working tree format 3
+        branch: Branch format 4
+    repository: Weave repository format 6
 
 Working tree is out of date: missing 1 revision.
 
@@ -422,14 +437,15 @@
         out, err = self.runbzr('info tree/lightcheckout')
         self.assertEqualDiff(
 """Location:
-        checkout root: %s
-   checkout of branch: %s
-    shared repository: %s
+       checkout root: %s
+  checkout of branch: %s
+   shared repository: %s
 
 Format:
-  working tree format: Bazaar-NG Working Tree format 3
-        branch format: Bazaar-NG branch format 5
-    repository format: Bazaar-NG Repository format 7
+       control: Meta directory format 1
+  working tree: Working tree format 3
+        branch: Branch format 5
+    repository: Weave repository format 7
 
 In the working tree:
          0 unchanged
@@ -461,13 +477,14 @@
         out, err = self.runbzr('info tree/checkout')
         self.assertEqualDiff(
 """Location:
-          branch root: %s
-      bound to branch: %s
+         branch root: %s
+     bound to branch: %s
 
 Format:
-  working tree format: Bazaar-NG Working Tree format 3
-        branch format: Bazaar-NG branch format 5
-    repository format: Bazaar-NG Repository format 7
+       control: Meta directory format 1
+  working tree: Working tree format 3
+        branch: Branch format 5
+    repository: Weave repository format 7
 
 In the working tree:
          0 unchanged
@@ -499,14 +516,15 @@
         out, err = self.runbzr('info tree/lightcheckout')
         self.assertEqualDiff(
 """Location:
-        checkout root: %s
-   checkout of branch: %s
-    shared repository: %s
+       checkout root: %s
+  checkout of branch: %s
+   shared repository: %s
 
 Format:
-  working tree format: Bazaar-NG Working Tree format 3
-        branch format: Bazaar-NG branch format 5
-    repository format: Bazaar-NG Repository format 7
+       control: Meta directory format 1
+  working tree: Working tree format 3
+        branch: Branch format 5
+    repository: Weave repository format 7
 
 In the working tree:
          1 unchanged
@@ -538,13 +556,14 @@
         out, err = self.runbzr('info tree/checkout')
         self.assertEqualDiff(
 """Location:
-          branch root: %s
-      bound to branch: %s
+         branch root: %s
+     bound to branch: %s
 
 Format:
-  working tree format: Bazaar-NG Working Tree format 3
-        branch format: Bazaar-NG branch format 5
-    repository format: Bazaar-NG Repository format 7
+       control: Meta directory format 1
+  working tree: Working tree format 3
+        branch: Branch format 5
+    repository: Weave repository format 7
 
 Branch is out of date: missing 1 revision.
 
@@ -576,13 +595,14 @@
         out, err = self.runbzr('info tree/checkout')
         self.assertEqualDiff(
 """Location:
-          branch root: %s
-      bound to branch: %s
+         branch root: %s
+     bound to branch: %s
 
 Format:
-  working tree format: Bazaar-NG Working Tree format 3
-        branch format: Bazaar-NG branch format 5
-    repository format: Bazaar-NG Repository format 7
+       control: Meta directory format 1
+  working tree: Working tree format 3
+        branch: Branch format 5
+    repository: Weave repository format 7
 
 In the working tree:
          1 unchanged
@@ -615,14 +635,15 @@
         out, err = self.runbzr('info tree/lightcheckout')
         self.assertEqualDiff(
 """Location:
-        checkout root: %s
-   checkout of branch: %s
-    shared repository: %s
+       checkout root: %s
+  checkout of branch: %s
+   shared repository: %s
 
 Format:
-  working tree format: Bazaar-NG Working Tree format 3
-        branch format: Bazaar-NG branch format 5
-    repository format: Bazaar-NG Repository format 7
+       control: Meta directory format 1
+  working tree: Working tree format 3
+        branch: Branch format 5
+    repository: Weave repository format 7
 
 Working tree is out of date: missing 1 revision.
 
@@ -670,13 +691,14 @@
         out, err = self.runbzr('info repo/branch1')
         self.assertEqualDiff(
 """Location:
-          branch root: %s
-    shared repository: %s
+         branch root: %s
+   shared repository: %s
 
 Format:
-  working tree format: Bazaar-NG Working Tree format 3
-        branch format: Bazaar-NG branch format 5
-    repository format: Bazaar-NG Repository format 7
+       control: Meta directory format 1
+  working tree: Working tree format 3
+        branch: Branch format 5
+    repository: Weave repository format 7
 
 In the working tree:
          0 unchanged
@@ -709,13 +731,14 @@
         out, err = self.runbzr('info repo/branch1')
         self.assertEqualDiff(
 """Location:
-          branch root: %s
-    shared repository: %s
+         branch root: %s
+   shared repository: %s
 
 Format:
-  working tree format: Bazaar-NG Working Tree format 3
-        branch format: Bazaar-NG branch format 5
-    repository format: Bazaar-NG Repository format 7
+       control: Meta directory format 1
+  working tree: Working tree format 3
+        branch: Branch format 5
+    repository: Weave repository format 7
 
 In the working tree:
          1 unchanged
@@ -745,14 +768,15 @@
         out, err = self.runbzr('info repo/branch2')
         self.assertEqualDiff(
 """Location:
-          branch root: %s
-    shared repository: %s
-        parent branch: %s
+         branch root: %s
+   shared repository: %s
+       parent branch: %s
 
 Format:
-  working tree format: Bazaar-NG Working Tree format 3
-        branch format: Bazaar-NG branch format 5
-    repository format: Bazaar-NG Repository format 7
+       control: Meta directory format 1
+  working tree: Working tree format 3
+        branch: Branch format 5
+    repository: Weave repository format 7
 
 In the working tree:
          0 unchanged
@@ -781,14 +805,15 @@
         out, err = self.runbzr('info repo/branch2')
         self.assertEqualDiff(
 """Location:
-          branch root: %s
-    shared repository: %s
-        parent branch: %s
+         branch root: %s
+   shared repository: %s
+       parent branch: %s
 
 Format:
-  working tree format: Bazaar-NG Working Tree format 3
-        branch format: Bazaar-NG branch format 5
-    repository format: Bazaar-NG Repository format 7
+       control: Meta directory format 1
+  working tree: Working tree format 3
+        branch: Branch format 5
+    repository: Weave repository format 7
 
 In the working tree:
          1 unchanged

=== modified file 'bzrlib/tests/branch_implementations/test_branch.py'
--- bzrlib/tests/branch_implementations/test_branch.py	2006-03-07 12:17:32 +0000
+++ bzrlib/tests/branch_implementations/test_branch.py	2006-04-06 13:07:40 +0000
@@ -322,6 +322,11 @@
         self.assertEqual(repo.bzrdir.root_transport.base,
                          child_branch.repository.bzrdir.root_transport.base)
 
+    def test_format_description(self):
+        tree = self.make_branch_and_tree('tree')
+        text = tree.branch._format.get_format_description()
+        self.failUnless(len(text))
+
 
 class ChrootedTests(TestCaseWithBranch):
     """A support class that provides readonly urls outside the local namespace.

=== modified file 'bzrlib/tests/bzrdir_implementations/test_bzrdir.py'
--- bzrlib/tests/bzrdir_implementations/test_bzrdir.py	2006-03-07 09:03:44 +0000
+++ bzrlib/tests/bzrdir_implementations/test_bzrdir.py	2006-04-06 13:07:40 +0000
@@ -1080,6 +1080,11 @@
             # and it should pass 'check' now.
             check(bzrdir.BzrDir.open(self.get_url('.')).open_branch(), False)
 
+    def test_format_description(self):
+        dir = self.make_bzrdir('.')
+        text = dir._format.get_format_description()
+        self.failUnless(len(text))
+
 
 class ChrootedBzrDirTests(ChrootedTestCase):
 

=== modified file 'bzrlib/tests/repository_implementations/test_repository.py'
--- bzrlib/tests/repository_implementations/test_repository.py	2006-03-09 00:59:01 +0000
+++ bzrlib/tests/repository_implementations/test_repository.py	2006-04-06 13:07:40 +0000
@@ -250,6 +250,11 @@
         repo.unlock()
         self.assertRaises(errors.OutSideTransaction, inv.add_lines, 'foo', [], [])
 
+    def test_format_description(self):
+        repo = self.make_repository('.')
+        text = repo._format.get_format_description()
+        self.failUnless(len(text))
+
 
 class TestCaseWithComplexRepository(TestCaseWithRepository):
 

=== modified file 'bzrlib/tests/workingtree_implementations/test_workingtree.py'
--- bzrlib/tests/workingtree_implementations/test_workingtree.py	2006-03-07 18:41:18 +0000
+++ bzrlib/tests/workingtree_implementations/test_workingtree.py	2006-04-06 13:07:40 +0000
@@ -503,3 +503,9 @@
         tree = self.make_branch_and_tree('master')
         tree._control_files.put('merge-hashes', StringIO('asdfasdf'))
         self.assertRaises(errors.MergeModifiedFormatError, tree.merge_modified)
+
+    def test_format_description(self):
+        tree = self.make_branch_and_tree('tree')
+        text = tree._format.get_format_description()
+        self.failUnless(len(text))
+

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2006-03-11 19:49:50 +0000
+++ bzrlib/workingtree.py	2006-04-06 13:07:40 +0000
@@ -1372,6 +1372,10 @@
         """Return the ASCII format string that identifies this format."""
         raise NotImplementedError(self.get_format_string)
 
+    def get_format_description(self):
+        """Return the short description for this format."""
+        raise NotImplementedError(self.get_format_description)
+
     def is_supported(self):
         """Is this format supported?
 
@@ -1402,6 +1406,10 @@
     This format modified the hash cache from the format 1 hash cache.
     """
 
+    def get_format_description(self):
+        """See WorkingTreeFormat.get_format_description()."""
+        return "Working tree format 2"
+
     def initialize(self, a_bzrdir, revision_id=None):
         """See WorkingTreeFormat.initialize()."""
         if not isinstance(a_bzrdir.transport, LocalTransport):
@@ -1470,6 +1478,10 @@
         """See WorkingTreeFormat.get_format_string()."""
         return "Bazaar-NG Working Tree format 3"
 
+    def get_format_description(self):
+        """See WorkingTreeFormat.get_format_description()."""
+        return "Working tree format 3"
+
     _lock_file_name = 'lock'
     _lock_class = LockDir
 

